#include <sys/io.h>

#define DPORT base
#define SPORT (base+1)

int init_bits( char *device )
{
	int port;
	
	if( iopl( 3 ) != 0 )
	{
		perror( "iopl" );
		exit( 1 );
	}
	
	if( device )
	{
		if( sscanf( device, "%x", &port ) != 1 )
		{
			fprintf( stderr, "Invalid port number: %s\n", device );
			exit( 1 );
		}
		
		return( port );
	}
	else
	{
		return( 0x378 );
	}
}

inline void sendbits_1( int base, unsigned char data )
{
	outb( data & 0xef, DPORT );
	outb( data | 0x10, DPORT );
}

inline void sendbits_2( int base, unsigned char data )
{
	outb( data | 0x10, DPORT );
	outb( data & 0xef, DPORT );
}

inline unsigned char readbits_1( int base )
{
	unsigned char st;
	
	while( 1 )
	{
		st = inb( SPORT );
		if( !( st & 0x80 ) )
			return( ( st >> 3 ) & 0x0f );
	}
}

inline unsigned char readbits_2( int base )
{
	unsigned char st;
	
	while( 1 )
	{
		st = inb( SPORT );
		if( st & 0x80 )
			return( ( st >> 3 ) & 0x0f );
	}
}

inline unsigned char hs_readbits_1( int base )
{
	unsigned char st;
	
	st = inb( SPORT );
	if( st & 0x80 )
		return( 0 );
	else
		return( st >> 3 );
}

inline unsigned char hs_readbits_2( int base )
{
	unsigned char st;
	
	st = inb( SPORT );
	if( !( st & 0x80 ) )
		return( 0 );
	else
		return( st >> 3 );
}
